#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9;

struct s_tree {
    vector <int> a, sum, promise;
    int n;

    s_tree() {}


    s_tree(vector <int> _a) {
        a = _a;
        n = a.size();
        sum.resize(4 * n);
        promise.resize(4 * n, INF);
        build(0, 0, n);
    }

    void build(int id, int l, int r) {
        if (l + 1 == r) {
            sum[id] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(id * 2 + 1, l, m);
        build(id * 2 + 2, m, r);
        sum[id] = sum[id * 2 + 1] + sum[id * 2 + 2];
    }

    void push(long long id, long long l, long long r) {
        if (promise[id] == INF) {
            return;
        }
        sum[id] = (r - l) * promise[id];
        if (r - l > 1) {
            promise[id * 2 + 1] = promise[id];
            promise[id * 2 + 2] = promise[id];
        }
        promise[id] = INF;
    }

    int get(int id, int l, int r, int q_l, int q_r) {
        push(id, l, r);
        if (q_l <= l && r <= q_r) {
            return sum[id];
        }
        if (q_l >= r || q_r <= l) {
            return 0;
        }
        int m = (l + r) / 2;
        int s1 = get(id * 2 + 1, l, m, q_l, q_r);
        int s2 = get(id * 2 + 2, m, r, q_l, q_r);
        return s1 + s2;
    }

    void upd(int id, int l, int r, int q_l, int q_r, int up) {
        push(id, l, r);
        if (q_l <= l && r <= q_r) {
            promise[id] = up;
            return;
        }
        if (q_l >= r || q_r <= l) {
            return;
        }
        int m = (l + r) / 2;
        upd(id * 2 + 1, l, m, q_l, q_r, up);
        upd(id * 2 + 2, m, r, q_l, q_r, up);
        sum[id] = sum[id * 2 + 1] + sum[id * 2 + 2];
    }

    void write() {
        for (int i = 0; i < n; ++i) {
            cout << get(0, 0, n, i, i + 1) << " ";
        }
        cout << endl;
    }
};


vector <vector <long long>> rig, lef, up, down;
//vector <vector <long long>> right, left, up, down;


long long get_right(long long v, long long i) {
    if (v == rig[i][v]) {
        return v;
    }
    return rig[i][v] = get_right(rig[i][v], i);
}

long long get_left(long long v, long long i) {
    if (v == lef[i][v]) {
        return v;
    }
    return lef[i][v] = get_left(lef[i][v], i);
}

long long get_up(long long v, long long j) {
    if (v == up[v][j]) {
        return v;
    }
    return up[v][j] = get_up(up[v][j], j);
}

long long get_down(long long v, long long j) {
    //cout << v << " " << j << endl;
    if (v == down[v][j]) {
        return v;
    }
    return down[v][j] = get_down(down[v][j], j);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long h, w, d, n, x, y, c, k, p;
    cin >> h >> w >> d;
    char a[h][w];
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                x = i;
                y = j;
            }
        }
    }
    cin >> n;
    vector <char> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    if (d == 1) {
        k = 0;
        vector <vector <int>> g(h, vector <int> (w, 0));
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                if (a[i][j] == 'K') {
                    g[i][j] = 1;
                    //cout << j << endl;
                }
            }
        }
        vector <s_tree> s(h);
        for (int i = 0; i < h; ++i) {
            s_tree s1(g[i]);
            //s1.write();
            s[i] = s1;
        }

        vector <s_tree> s2(w);
        for (int i = 0; i < w; ++i) {
            vector <int> s3;
            for (int j = 0; j < h; ++j) {
                s3.push_back(g[j][i]);
            }
            s_tree s1(s3);
            //s1.write();
            s2[i] = s1;
        }
        //s[0].write();
        //cout << s[0].get(0, 0, w, 0, w) << endl;
        rig.resize(h + 2, vector <long long> (w + 2, w + 1));
        lef.resize(h + 2, vector <long long> (w + 2, 0));
        up.resize(h + 2, vector <long long> (w + 2, 0));
        down.resize(h + 2, vector <long long> (w + 2, h + 1));
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                if (a[i][j] == '#' || a[i][j] == 'L') {
                    rig[i + 1][j + 1] = j + 1;
                    lef[i + 1][j + 1] = j + 1;
                    up[i + 1][j + 1] = i + 1;
                    down[i + 1][j + 1] = i + 1;
                }
                else {
                    rig[i + 1][j + 1] = j + 2;
                    lef[i + 1][j + 1] = j;
                    up[i + 1][j + 1] = i;
                    down[i + 1][j + 1] = i + 2;
                }
            }
        }
        ++x;
        ++y;
        k = 0;
        for (int i = 0; i < n; ++i) {
            if (b[i] == 'R') {
                p = y;
                c = get_right(y, x);
                k += s[x - 1].get(0, 0, w, y, c);
                //cout << y << " " << c << " " << k << endl;
                s[x - 1].upd(0, 0, w, y - 1, c, 0);

                y = c - 1;
                while (k > 0 && c <= w && a[x - 1][c - 1] == 'L') {
                    //cout << k << " " << c << endl;
                    rig[x][c] = c + 1;
                    lef[x][c] = c - 1;
                    down[x][c] = x + 1;
                    up[x][c] = x - 1;
                    c = get_right(y, x);
                    k -= 1;
                    k += s[x - 1].get(0, 0, w, y, c);
                    s[x - 1].upd(0, 0, w, y, c, 0);
                    y = c - 1;

                }

                //cout << c << endl;
                cout << c - p - 1 << endl;
                y = c - 1;
            }
            if (b[i] == 'L') {

                p = y;
                c = get_left(y, x);
                k += s[x - 1].get(0, 0, w, c, y);
                //cout << y << " " << c << " " << k << endl;
                s[x - 1].upd(0, 0, w, c - 1, y, 0);

                y = c + 1;
                while (k > 0 && c >= 1 && a[x - 1][c - 1] == 'L') {
                    //cout << k << " " << c << endl;
                    rig[x][c] = c + 1;
                    lef[x][c] = c - 1;
                    down[x][c] = x + 1;
                    up[x][c] = x - 1;
                    c = get_left(y, x);
                    k -= 1;
                    k += s[x - 1].get(0, 0, w, c, y);
                    s[x - 1].upd(0, 0, w, c - 1, y, 0);
                    y = c + 1;

                }
                c = get_left(y, x);
                //cout << c << endl;
                cout << p - c - 1 << endl;
                y = c + 1;
            }
            if (b[i] == 'U') {

                p = x;
                c = get_up(x, y);
                k += s2[y - 1].get(0, 0, h, c, x);
                //cout << x << " " << c << " " << k << endl;
                s2[x - 1].upd(0, 0, h, c, x, 0);

                x = c + 1;
                while (k > 0 && c >= 1 && a[c - 1][y - 1] == 'L') {
                    //cout << k << " " << c << endl;
                    down[x][c] = c + 1;
                    up[x][c] = c - 1;
                    lef[c][y] = x - 1;
                    rig[c][y] = x + 1;
                    c = get_up(x, y);
                    k -= 1;
                    k += s2[y - 1].get(0, 0, h, c, x);
                    s2[x - 1].upd(0, 0, h, c, x, 0);
                    x = c + 1;

                }

                //cout << c << endl;
                cout << p - c - 1 << endl;
                x = c + 1;


                //c = get_up(x, y);
                //cout << x - c - 1 << endl;
                //x = c + 1;
            }
            if (b[i] == 'D') {
                p = x;
                c = get_down(x, y);
                k += s2[y - 1].get(0, 0, h, x, x);
                //cout << x << " " << c << " " << k << endl;
                s2[x - 1].upd(0, 0, h, x, c, 0);

                x = c - 1;
                while (k > 0 && c <= h && a[c - 1][y - 1] == 'L') {
                    //cout << k << " " << c << endl;
                    down[c][y] = c + 1;
                    up[c][y] = c - 1;
                    lef[c][y] = x - 1;
                    rig[c][y] = x + 1;
                    c = get_down(x, y);
                    k -= 1;
                    k += s2[y - 1].get(0, 0, h, x, c);
                    s2[x - 1].upd(0, 0, h, x, c, 0);
                    x = c - 1;

                }

                //c = get_down(x, y);
                cout << c - p - 1 << endl;
                x = c - 1;
            }
        }
        //cout << "2\n0\n4\n4";
        return 0;
    }
    rig.resize(h + 2, vector <long long> (w + 2, w + 1));
    lef.resize(h + 2, vector <long long> (w + 2, 0));
    up.resize(h + 2, vector <long long> (w + 2, 0));
    down.resize(h + 2, vector <long long> (w + 2, h + 1));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == '#') {
                rig[i + 1][j + 1] = j + 1;
                lef[i + 1][j + 1] = j + 1;
                up[i + 1][j + 1] = i + 1;
                down[i + 1][j + 1] = i + 1;
            }
            else {
                rig[i + 1][j + 1] = j + 2;
                lef[i + 1][j + 1] = j;
                up[i + 1][j + 1] = i;
                down[i + 1][j + 1] = i + 2;
            }
        }
    }
    ++x;
    ++y;
    for (int i = 0; i < n; ++i) {
        if (b[i] == 'R') {
            c = get_right(y, x);
            //cout << c << endl;
            cout << c - y - 1 << endl;
            y = c - 1;
        }
        if (b[i] == 'L') {
            c = get_left(y, x);
            cout << y - c - 1 << endl;
            y = c + 1;
        }
        if (b[i] == 'U') {
            c = get_up(x, y);
            cout << x - c - 1 << endl;
            x = c + 1;
        }
        if (b[i] == 'D') {
            c = get_down(x, y);
            cout << c - x - 1 << endl;
            x = c - 1;
        }
    }
}
