#include <iostream>
#include <math.h>
#include <string>
#include <vector>
#include <map>
#include <set>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 2e18 + 13;

set<int> gr[maxn];
bool ok[maxn];
string names[maxn];
int cnt = 0;
void dfs(int u, string &res){
	ok[u] = 1;
	if(gr[u].size() > 1){
		res = "TOO COMPLEX";
		return;
	}
	for(auto t : gr[u]){
		if(t == u){
			res = names[u];
			return;
		}
		if(ok[t] && t != u){
			res = "INFINITE LOOP";
			return;
		}
		dfs(t, res);
		if(res != "")return;
	}
	if(res != "")return;
	if(gr[u].size() == 0)res = names[u];
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	map<string, int> mp;
	for(int i = 1; i <= n; ++i){
		string u, v;
		cin >> u >> v >> v;
		if(mp.find(u) == mp.end())mp[u] = ++cnt, names[cnt] = u;
		if(mp.find(v) == mp.end())mp[v] = ++cnt, names[cnt] = v;
		int d1 = mp[u], d2 = mp[v];
		gr[d1].insert(d2);
	}
	int q;
	cin >> q;
	while(q--){
		char c;
		cin >> c;
		if(c == '+'){
			string u, v;
			cin >> u >> v >> v;
			if(mp.find(u) == mp.end())mp[u] = ++cnt, names[cnt] = u;
			if(mp.find(v) == mp.end())mp[v] = ++cnt, names[cnt] = v;
			int d1 = mp[u], d2 = mp[v];
			gr[d1].insert(d2);
		}else{
			string s;
			cin >> s;
			if(mp.find(s) == mp.end())mp[s] = ++cnt, names[cnt] = s;
			for(int i = 1; i <= cnt; ++i)ok[i] = 0;
			string res = "";
			dfs(mp[s], res);
			cout << res << "\n";
		}
	}
	return 0;
}