#include <iostream>
#include <math.h>
#include <string>
#include <vector>
#include <map>
#include <set>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 2e18 + 13;
bool ok(int x, int y, int m){
	return 1 <= x && x <= m && 1 <= y && y <= m;
}
void solve(){
	int m, n;
	cin >> m >> n;
	vector<vector<int>> chess(m + 3, vector<int>(m + 3, 0));
	vector<pair<int, int>> st;
	for(int i = 1; i <= n; ++i){
		int x, y;
		cin >> y >> x;
		for(int j = 1; j <= m; ++j)chess[x][j]++;
		for(int j = 1; j <= m; ++j)chess[j][y]++;
		int cx = x + 1, cy = y + 1;
		while(ok(cx,cy, m))chess[cx++][cy++]++;
		cx = x - 1, cy = y - 1;
		while(ok(cx,cy, m))chess[cx--][cy--]++;
		cx = x - 1, cy = y + 1;
		while(ok(cx,cy, m))chess[cx--][cy++]++;
		cx = x + 1, cy = y - 1;
		while(ok(cx,cy, m))chess[cx++][cy--]++;
		st.push_back({x, y});
	}	
	for(auto t : st){
		int x = t.first, y = t.second;
		chess[x][y] = chess[x - 1][y - 1] = chess[x + 1][y + 1] = 0;
		chess[x - 1][y] = chess[x][y - 1] = chess[x + 1][y] = chess[x][y + 1] = 0;
		chess[x - 1][y + 1] = chess[x + 1][y - 1] = 0;
	}
	int cnt = 0;
	for(int i = 1; i <= m; ++i){
		for(int j = 1; j <= m; ++j){
			if(chess[i][j] == n)cnt++;
		}
	}
	cout << cnt << "\n";
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int q;
	cin >> q;
	while(q--)solve();


	return 0;
}