#include <iostream>
#include <string>
#include <vector>

using namespace std;

int main()
{
	int h, w, d, l, ci = 0, cj = 0;
	cin >> h >> w >> d;
	vector<string> v(h);
	for (int i = 0; i < h; ++i)
	{
		cin >> v[i];
		for (int j = 0; j < w; ++j)
			if (v[i][j] == 'S')
			{
				v[i][j] = '.';
				ci = i;
				cj = j;
			}
	}
	cin >> l;
	string s;
	cin >> s;

	if (d == 0)
	{
		vector<vector<vector<int>>> wall(4, vector<vector<int>>(h, vector<int>(w))); // 0 - up, 1 - left, 2 - down, 3 - right
		for (int i = 0; i < h; ++i)
			for (int j = 0; j < w; ++j)
				if (v[i][j] == '#') wall[0][i][j] = wall[1][i][j] = -1;
				else
				{
					if (i > 0) wall[0][i][j] = wall[0][i - 1][j] + 1;
					if (j > 0) wall[1][i][j] = wall[1][i][j - 1] + 1;
				}
		for (int i = h - 1; i >= 0; --i)
			for (int j = w - 1; j >= 0; --j)
				if (v[i][j] == '#') wall[2][i][j] = wall[3][i][j] = -1;
				else
				{
					if (i < h - 1) wall[2][i][j] = wall[2][i + 1][j] + 1;
					if (j < w - 1) wall[3][i][j] = wall[3][i][j + 1] + 1;
				}
		for (int i = 0; i < l; ++i)
		{
			if (s[i] == 'U')
			{
				cout << wall[0][ci][cj];
				ci -= wall[0][ci][cj];
			} else if (s[i] == 'L')
			{
				cout << wall[1][ci][cj];
				cj -= wall[1][ci][cj];
			}
			else if (s[i] == 'D')
			{
				cout << wall[2][ci][cj];
				ci += wall[2][ci][cj];
			}
			else if (s[i] == 'R')
			{
				cout << wall[3][ci][cj];
				cj += wall[3][ci][cj];
			}
			cout << '\n';
		}
		return 0;
	}

	int keys = 0;
	for (int i = 0; i < l; ++i)
	{
		int r = 0;
		pair<int, int> p;
		if (s[i] == 'R') p = { 0, 1 };
		else if (s[i] == 'L') p = { 0, -1 };
		else if (s[i] == 'U') p = { -1, 0 };
		else p = { 1, 0 };
		while (true)
		{
			int ni = ci + p.first, nj = cj + p.second;
			if (ni < 0 || ni >= h || nj < 0 || nj >= w || v[ni][nj] == '#') break;
			if (v[ni][nj] == 'K')
			{
				++keys;
				v[ni][nj] = '.';
			}
			else if (v[ni][nj] == 'L')
			{
				if (keys > 0)
				{
					--keys;
					v[ni][nj] = '.';
				}
				else break;
			}
			++r;
			ci = ni;
			cj = nj;
		}
		cout << r << '\n';
	}
}