#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>

using namespace std;

struct ancestor
{
	string anc, res = "__";
	bool init = false;
	bool too_complex = false;
	bool infinite = false;
	int nq = -1;
};

unordered_map<string, ancestor> mp;

string get(string cur, int nq)
{
	//if (mp[cur])
	if (mp[cur].too_complex) return "TOO COMPLEX";
	if (mp[cur].nq == nq || mp[cur].infinite) return "INFINITE LOOP";
	if (!mp[cur].init || mp[cur].anc == cur) return cur;
	mp[cur].nq = nq;
	string res = get(mp[cur].anc, nq);
	if (res.find(' ') != -1) mp[cur].anc = res;
	if (res == "TOO COMPLEX") mp[cur].too_complex = true;
	if (res == "INFINITE LOOP") mp[cur].infinite = true;
	return res;
}

int main()
{
	int n, cur = 0;
	cin >> n;
	vector<string> names;
	for (int i = 0; i < n; ++i)
	{
		string fr, s, to;
		cin >> fr >> s >> to;
		if (mp[fr].init && mp[fr].anc != to)
		{
			mp[fr].too_complex = true;
			//string nm = get(fr, i);
			//mp[nm].too_complex = true;
		}
		else
		{
			mp[fr].anc = to;
			mp[fr].init = true;
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		string type;
		cin >> type;
		if (type == "?")
		{
			string s;
			cin >> s;
			cout << get(s, i) << '\n';
		} else
		{
			string fr, s, to;
			cin >> fr >> s >> to;
			if (mp[fr].init && mp[fr].anc != to)
			{
				mp[fr].too_complex = true;
				//string nm = get(fr, i);
				//mp[nm].too_complex = true;
			} else
			{
				mp[fr].anc = to;
				mp[fr].init = true;
			}
		}
	}
}