#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#include <intrin.h>

#include <bits/stdc++.h>
#include <chrono>
#include <random>
#include <ctime>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define rep(i, n) for (ll i = 0; i < (n); i++)
#define repb(i, n) for (ll i = n - 1; i>=0; --i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const ll inf = 1e9;
const ll MAXN = 1e5;

struct Segment {
    int l;
    int r;

    Segment() {
        l = -1;
        r = -1;
    }

    Segment(int _l, int _r) {
        l = _l;
        r = _r;
    }
};

struct Segment_tree {
    int sz;
    vector<int> t;

    Segment_tree(int _n) {
        sz = _n;
        t.resize(4 * sz);
    }

    void modify(int v, int l, int r, int idx, int val) {
        if (r - l == 1) {
            t[v] = val;
            return;
        }
        int m = l + r >> 1;
        if (idx < m)
            modify(2 * v, l, m, idx, val);
        else
            modify(2 * v + 1, m, r, idx, val);
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }

    pair<int, Segment> first_right_scaling(int v, int tl, int tr, int l, int r) { // либо поиск справа, либо поиск снизу
        if (tl >= r || tr <= l)
            return mp(-1, Segment());
        else if (l <= tl && tr <= r) {
            if (t[v])
                return mp(v, Segment(tl, tr));
            return mp(-1, Segment());
        }
        int m = tl + tr >> 1;
        pair<int, Segment> a = first_right_scaling(2 * v, tl, m, l, r);
        pair<int, Segment> b = first_right_scaling(2 * v + 1, m, tr, l, r);
        if (a.first != -1)
            return a;
        return b;
    }

    int second_right_scaling(int v, int l, int r) {
        if (r - l == 1) {
            if (t[v])
                return l;
            return -1;
        }
        int m = l + r >> 1;
        if (t[2 * v])
            return second_right_scaling(2 * v, l, m);
        return second_right_scaling(2 * v + 1, m, r);
    }

    pair<int, Segment> first_left_scaling(int v, int tl, int tr, int l, int r) { // либо поиск слева, либо поиск сверху
        if (tl >= r || tr <= l)
            return mp(-1, Segment());
        else if (l <= tl && tr <= r) {
            if (t[v])
                return mp(v, Segment(tl, tr));
            return mp(-1, Segment());
        }
        int m = tl + tr >> 1;
        pair<int, Segment> a = first_left_scaling(2 * v, tl, m, l, r);
        pair<int, Segment> b = first_left_scaling(2 * v + 1, m, tr, l, r);
        if (b.first != -1)
            return b;
        return a;
    }

    int second_left_scaling(int v, int l, int r) {
        if (r - l == 1) {
            if (t[v])
                return l;
            return -1;
        }
        int m = l + r >> 1;
        if (t[2 * v + 1])
            return second_left_scaling(2 * v + 1, m, r);
        return second_left_scaling(2 * v, l, m);
    }

};


int get_type(char c) {
    if (c == '.')
        return 0;
    else if (c == 'K')
        return 1;
    else if (c == 'L')
        return 2;
    else if (c == '#')
        return 3;
}

// до на ключи и до на двери


int get_dist(pair<int, int> a, pair<int, int> b) {
    return abs(a.first - b.first) + abs(a.second - b.second);
}

vector<vector<char>> a;

inline void SOLVE() {
    int n, m, d;
    cin >> n >> m >> d;

    a.resize(n + 2, vector<char>(m + 2, '#'));
    pair<int, int> cur;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                cur = mp(i, j);
                a[i][j] = '.';
            }
        }
    }
    n = n + 2;
    m = m + 2;
    vector<Segment_tree> hor(n, Segment_tree(m));
    vector<Segment_tree> vert(m, Segment_tree(n));
    // заполняем ДО
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            hor[i].modify(1, 0, m, j, get_type(a[i][j]));
            vert[j].modify(1, 0, n, i, get_type(a[i][j]));
        }
    }
    int L;
    cin >> L;
    string s;
    cin >> s;
    int key_counter = 0;
    rep(p, L) {
        pair<int, int> prv = cur;
        if (s[p] == 'R') {
            // используется горизонтальное до и право
            Segment_tree &t = hor[cur.first];
            while (true) {
                pair<int, Segment> x = t.first_right_scaling(1, 0, t.sz, prv.second, t.sz);
                if (x.first != -1) {
                    int nx = t.second_right_scaling(x.first, x.second.l, x.second.r);
                    Segment_tree &opposite = vert[nx];
                    int e = get_type(a[cur.first][nx]);
                    if (e == 3) {
                        cur.second = nx - 1;
                        break;
                    } else if (e == 2) {
                        if (key_counter) {
                            key_counter--;
                            t.modify(1, 0, t.sz, nx, 0);
                            opposite.modify(1, 0, opposite.sz, prv.first, 0);
                        } else {
                            cur.second = nx - 1;
                            break;
                        }
                    } else if (e == 1) {
                        key_counter++;
                        t.modify(1, 0, t.sz, nx, 0);
                        opposite.modify(1, 0, opposite.sz, prv.first, 0);
                    }
                }
            }
        } else if (s[p] == 'L') {
            // используется горизонтальное до и лево
            Segment_tree &t = hor[cur.first];
            while (true) {
                pair<int, Segment> x = t.first_left_scaling(1, 0, t.sz, 0, prv.second);
                if (x.first != -1) {
                    int nx = t.second_left_scaling(x.first, x.second.l, x.second.r);
                    Segment_tree &opposite = vert[nx];
                    int e = get_type(a[cur.first][nx]);
                    if (e == 3) {
                        cur.second = nx + 1;
                        break;
                    } else if (e == 2) {
                        if (key_counter) {
                            key_counter--;
                            t.modify(1, 0, t.sz, nx, 0);
                            opposite.modify(1, 0, opposite.sz, prv.first, 0);
                        } else {
                            cur.second = nx + 1;
                            break;
                        }
                    } else if (e == 1) {
                        key_counter++;
                        t.modify(1, 0, t.sz, nx, 0);
                        opposite.modify(1, 0, opposite.sz, prv.first, 0);
                    }
                }
            }
        } else if (s[p] == 'U') {
            // используется горизонтальное до и лево
            Segment_tree &t = vert[cur.second];
            while (true) {
                pair<int, Segment> x = t.first_left_scaling(1, 0, t.sz, 0, prv.first);
                if (x.first != -1) {
                    int nx = t.second_left_scaling(x.first, x.second.l, x.second.r);
                    Segment_tree &opposite = hor[nx];
                    int e = get_type(a[nx][prv.second]);
                    if (e == 3) {
                        cur = mp(nx + 1, prv.second);
                        break;
                    } else if (e == 2) {
                        if (key_counter) {
                            key_counter--;
                            t.modify(1, 0, t.sz, nx, 0);
                            opposite.modify(1, 0, opposite.sz, prv.second, 0);
                        } else {
                            cur = mp(nx + 1, prv.second);
                            break;
                        }
                    } else if (e == 1) {
                        key_counter++;
                        t.modify(1, 0, t.sz, nx, 0);
                        opposite.modify(1, 0, opposite.sz, prv.second, 0);
                    }
                }
            }
        } else if (s[p] == 'D') {
            // используется горизонтальное до и лево
            Segment_tree &t = vert[cur.second];
            while (true) {
                pair<int, Segment> x = t.first_right_scaling(1, 0, t.sz, prv.first, t.sz);
                if (x.first != -1) {
                    int nx = t.second_right_scaling(x.first, x.second.l, x.second.r);
                    Segment_tree &opposite = hor[nx];
                    int e = get_type(a[nx][prv.second]);
                    if (e == 3) {
                        cur = mp(nx - 1, prv.second);
                        break;
                    } else if (e == 2) {
                        if (key_counter) {
                            key_counter--;
                            t.modify(1, 0, t.sz, nx, 0);
                            opposite.modify(1, 0, opposite.sz, prv.second, 0);
                        } else {
                            cur = mp(nx - 1, prv.second);
                            break;
                        }
                    } else if (e == 1) {
                        key_counter++;
                        t.modify(1, 0, t.sz, nx, 0);
                        opposite.modify(1, 0, opposite.sz, prv.second, 0);
                    }
                }
            }
        }
        cout << get_dist(prv, cur) << '\n';
    }
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IQ();
    ll T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
    return 0;
}