#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int h, w, d;
    cin >> h >> w >> d;
    vector<vector<int>> a(h, vector<int> (w, 0));
    // 0 - empty
    // 1 - wall
    // 2 - key
    // 3 - door
    pii pos = {-1, -1};
    for (int i = 0; i < h; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < w; ++j) {
            if (s[j] == 'S') {
                pos = {i, j};
                a[i][j] = 0;
            }
            else if (s[j] == '.') {
                a[i][j] = 0;
            }
            else if (s[j] == '#') {
                a[i][j] = 1;
            }
            else if (s[j] == 'K') {
                a[i][j] = 2;
            }
            else if (s[j] == 'L') {
                a[i][j] = 3;
            }
        }
    }
    int n;
    string go;
    cin >> n >> go;
    if (d == 0) {
        vector<vector<int>> LEFT(h, vector<int> (w, 0)), RIGHT(h, vector<int> (w, 0)), UP(h, vector<int> (w, 0)), DOWN(h, vector<int> (w, 0));
        for (int i = 0; i < h; ++i) {
            int x = 0;
            for (int j = 0; j < w; ++j) {
                if (a[i][j] == 1) {
                    x = j + 1;
                    LEFT[i][j] = -1;
                }
                else {
                    LEFT[i][j] = x;
                }
            }

            x = w - 1;
            for (int j = w - 1; j >= 0; --j) {
                if (a[i][j] == 1) {
                    x = j - 1;
                    RIGHT[i][j] = -1;
                }
                else {
                    RIGHT[i][j] = x;
                }
            }
        }
        for (int j = 0; j < w; ++j) {
            int x = 0;
            for (int i = 0; i < h; ++i) {
                if (a[i][j] == 1) {
                    x = i + 1;
                    UP[i][j] = -1;
                }
                else {
                    UP[i][j] = x;
                }
            }

            x = h - 1;
            for (int i = h - 1; i >= 0; --i) {
                if (a[i][j] == 1) {
                    x = i - 1;
                    DOWN[i][j] = -1;
                }
                else {
                    DOWN[i][j] = x;
                }
            }
        }
        for (auto &i: go) {
            if (i == 'L') {
                int new_sec = LEFT[pos.first][pos.second];
                cout << abs(new_sec - pos.second) << en;
                pos.second = new_sec;
            }
            else if (i == 'R') {
                int new_sec = RIGHT[pos.first][pos.second];
                cout << abs(pos.second - new_sec) << en;
                pos.second = new_sec;
            }
            else if (i == 'U') {
                int new_fir = UP[pos.first][pos.second];
                cout << abs(pos.first - new_fir) << en;
                pos.first = new_fir;
            }
            else if (i == 'D') {
                int new_fir = DOWN[pos.first][pos.second];
                cout << abs(new_fir - pos.first) << en;
                pos.first = new_fir;
            }
        }
        return;
    }
    int keys = 0;
    for (auto &i: go) {
        int cnt = 0;
        if (i == 'U') {
            while (pos.first - 1 >= 0) {
                if (a[pos.first - 1][pos.second] == 1) {
                    break;
                }
                if (a[pos.first - 1][pos.second] == 3 && keys == 0) {
                    break;
                }
                if (a[pos.first - 1][pos.second] == 3) {
                    --keys;
                    a[pos.first - 1][pos.second] = 0;
                }
                --pos.first;
                if (a[pos.first][pos.second] == 2) {
                    ++keys;
                    a[pos.first][pos.second] = 0;
                }
                ++cnt;
            }
        }
        else if (i == 'D') {
            while (pos.first + 1 < h) {
                if (a[pos.first + 1][pos.second] == 1) {
                    break;
                }
                if (a[pos.first + 1][pos.second] == 3 && keys == 0) {
                    break;
                }
                if (a[pos.first + 1][pos.second] == 3) {
                    --keys;
                    a[pos.first + 1][pos.second] = 0;
                }
                ++pos.first;
                if (a[pos.first][pos.second] == 2) {
                    ++keys;
                    a[pos.first][pos.second] = 0;
                }
                ++cnt;
            }
        }
        else if (i == 'L') {
            while (pos.second - 1 >= 0) {
                if (a[pos.first][pos.second - 1] == 1) {
                    break;
                }
                if (a[pos.first][pos.second - 1] == 3 && keys == 0) {
                    break;
                }
                if (a[pos.first][pos.second - 1] == 3) {
                    --keys;
                    a[pos.first][pos.second - 1] = 0;
                }
                --pos.second;
                if (a[pos.first][pos.second] == 2) {
                    ++keys;
                    a[pos.first][pos.second] = 0;
                }
                ++cnt;
            }
        }
        else if (i == 'R') {
            while (pos.second + 1 < w) {
                if (a[pos.first][pos.second + 1] == 1) {
                    break;
                }
                if (a[pos.first][pos.second + 1] == 3 && keys == 0) {
                    break;
                }
                if (a[pos.first][pos.second + 1] == 3) {
                    --keys;
                    a[pos.first][pos.second + 1] = 0;
                }
                ++pos.second;
                if (a[pos.first][pos.second] == 2) {
                    ++keys;
                    a[pos.first][pos.second] = 0;
                }
                ++cnt;
            }
        }
        cout << cnt << en;
    }
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 1;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
