#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);
const string LOOP = "INFINITE LOOP";
const string COMPLEX = "TOO COMPLEX";

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

unordered_map<string, int> id;
unordered_map<int, string> name;
int CNT = 1;
unordered_map<int, unordered_set<int>> mp;
unordered_map<int, bool> used;
int beg;

int get(int a, int cnt = 0) {
    if (mp[a].empty() || (sz(mp[a]) == 1 && *mp[a].begin() == a)) {
        return a;
    }
    if (sz(mp[a]) > 1) {
        return -2;
    }
    int next = *mp[a].begin();
    if (next == beg) {
        if (cnt == 0) {
            return next;
        }
        else {
            return -1;
        }
    }
    if (used[next]) {
        return -1;
    }
    used[next] = 1;
    return get(next, cnt + 1);
}

unordered_map<int, int> par;

int dsu_get(int a) {
    if (par[a] == a) {
        return a;
    }
    return par[a] = dsu_get(par[a]);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string a, is, b;
        cin >> a >> is >> b;
        if (id[a] == 0) {
            id[a] = CNT;
            name[CNT] = a;
            ++CNT;
        }
        if (id[b] == 0) {
            id[b] = CNT;
            name[CNT] = b;
            ++CNT;
            par[id[b]] = id[b];
        }
        mp[id[a]].emplace(id[b]);
        par[id[a]] = id[b];
    }
    name[-1] = LOOP;
    name[-2] = COMPLEX;
    int q;
    cin >> q;
    if (q > 1000 || n > 1000) {
        while (q--) {
            string type;
            cin >> type;
            if (type[0] == '?') {
                string a;
                cin >> a;
                if (id[a] == 0) {
                    id[a] = CNT;
                    name[CNT] = a;
                    ++CNT;
                    par[id[a]] = id[a];
                }
                cout << name[dsu_get(id[a])] << en;
            }
            else {
                string a, is, b;
                cin >> a >> is >> b;
                if (id[a] == 0) {
                    id[a] = CNT;
                    name[CNT] = a;
                    ++CNT;
                }
                if (id[b] == 0) {
                    id[b] = CNT;
                    name[CNT] = b;
                    ++CNT;
                    par[id[b]] = id[b];
                }
                par[id[a]] = id[b];
            }
        }
        return;
    }
    while (q--) {
        string type;
        cin >> type;
        if (type[0] == '?') {
            string a;
            cin >> a;
            if (id[a] == 0) {
                id[a] = CNT;
                name[CNT] = a;
                ++CNT;
            }
            used.clear();
            beg = id[a];
            cout << name[get(id[a])] << en;
        }
        else {
            string a, is, b;
            cin >> a >> is >> b;
            if (id[a] == 0) {
                id[a] = CNT;
                name[CNT] = a;
                ++CNT;
            }
            if (id[b] == 0) {
                id[b] = CNT;
                name[CNT] = b;
                ++CNT;
            }
            mp[id[a]].emplace(id[b]);
        }
    }
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 1;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
