#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);
const int dx[8] = {1, 1, 1, 0, 0, -1, -1, -1};
const int dy[8] = {-1, 0, 1, -1, 1, -1, 0, 1};
const int gx[4] = {1, 1, -1, -1};
const int gy[4] = {1, -1, 1, -1};

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 0;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<vector<int>> a(m, vector<int> (m, 0)), bad(m, vector<int> (m, 0));
    for (int _ = 0; _ < n; ++_) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        bad[x][y] = 1;
        for (int c = 0; c < 8; ++c) {
            int xx = x + dx[c], yy = y + dy[c];
            if (0 <= xx && xx < m && 0 <= yy && yy < m) {
                bad[xx][yy] = 1;
            }
        }
        for (int j = 0; j < m; ++j) {
            ++a[x][j];
        }
        for (int i = 0; i < m; ++i) {
            ++a[i][y];
        }
        for (int u = 1; u < m; ++u) {
            for (int c = 0; c < 4; ++c) {
                int xx = x + u * gx[c], yy = y + u * gy[c];
                if (0 <= xx && xx < m && 0 <= yy && yy < m) {
                    ++a[xx][yy];
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            if (bad[i][j]) continue;
            if (a[i][j] == n) ++ans;
        }
    }
    cout << ans << en;
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 1;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
