#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

struct worker {
    int min_a, max_a, min_b, max_b;

    worker() {}

    worker(int minA, int maxA, int minB, int maxB) : min_a(minA), max_a(maxA), min_b(minB), max_b(maxB) {}
};


int n;
vector<vector<int>> g;
vector<ll> a, b, ans;
vector<vector<ll>> kek;

void dfs(int v) {
    for (int i = 1; i <= a[v]; ++i) {
        kek[v][i] = max(kek[v][i], b[v]);
    }
    for (auto &u: g[v]) {
        dfs(u);
        for (auto &k: kek[u]) {
            for (int i = 1; i <= 100; ++i) {
                kek[v][i] = max(kek[v][i], kek[u][i]);
            }
        }
    }
}

void solve() {
    cin >> n;
    g.resize(n + 1);
    a.resize(n + 1);
    b.resize(n + 1);
    ans.resize(n + 1);
    kek.resize(n + 1, vector<ll> (101, -INF));
    for (int i = 1; i <= n; ++i) {
        int p, aa, bb;
        cin >> p >> aa >> bb;
        a[i] = aa;
        b[i] = bb;
        if (!p) continue;
        g[p].emplace_back(i);
    }
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        ll cur = 0;
        for (int j = 1; j <= 100; ++j) {
            cur += (kek[i][j] >= 0 ? kek[i][j] : 0);
        }
        cout << cur << en;
    }
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 1;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
