﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, d; cin >> n >> m >> d;
    pair<int, int>start = { 0, 0 };
    vector<string>a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 'S') {
                start = { i, j };
            }
        }
    }
    vector<vector<int>>pref_key_i(n, vector<int>(m));
    vector<vector<int>>pref_key_j(m, vector<int>(n));
    vector<vector<int>>pref_close_i(n, vector<int>(m));
    vector<vector<int>>pref_close_j(m, vector<int>(n));
    vector<vector<int>>pref_door_i(n, vector<int>(m));
    vector<vector<int>>pref_door_j(m, vector<int>(n));
    for (int i = 0; i < n; i++) {
        int cnt_key = 0;
        if (a[i][0] == 'K') {
            pref_key_i[i][0] = 1;
        }
        int cnt_door = 0;
        if (a[i][0] == 'L') {
            pref_door_i[i][0] = 1;
        }
        int cnt_close = 0;
        if (a[i][0] == '#') {
            pref_close_i[i][0] = 1;
        }
        for (int j = 1; j < m; j++) {
            pref_key_i[i][j] = pref_key_i[i][j - 1];
            pref_close_i[i][j] = pref_close_i[i][j - 1];
            pref_door_i[i][j] = pref_door_i[i][j - 1];
            if (a[i][j] == 'K') {
                pref_key_i[i][j]++;
            }
            if (a[i][j] == 'L') {
                pref_door_i[i][j]++;
            }
            if (a[i][j] == '#') {
                pref_close_i[i][j]++;
            }
        }
    }
    for (int j = 0; j < m; j++) {
        int cnt_key = 0;
        if (a[0][j] == 'K') {
            pref_key_j[j][0] = 1;
        }
        int cnt_door = 0;
        if (a[0][j] == 'L') {
            pref_door_j[j][0] = 1;
        }
        int cnt_close = 0;
        if (a[0][j] == '#') {
            pref_close_j[j][0] = 1;
        }
        for (int i = 1; i < n; i++) {
            pref_key_j[j][i] = pref_key_j[j][i - 1];
            pref_close_j[j][i] = pref_close_j[j][i - 1];
            pref_door_j[j][i] = pref_door_j[j][i - 1];
            if (a[i][j] == 'K') {
                pref_key_j[j][i]++;
            }
            if (a[i][j] == 'L') {
                pref_door_j[j][i]++;
            }
            if (a[i][j] == '#') {
                pref_close_j[j][i]++;
            }
        }
    }
    int sz; cin >> sz;
    string s; cin >> s;
    if (d == 0) {
        int cnt_keys = 0;
        for (int i = 0; i < sz; i++) {
            if (s[i] == 'R') {
                // найти первую клетку, в которой единица
                // БП по скольки шагам я могу сделать [l, r)
                int l = 0, r = m - start.second;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans = pref_close_i[start.first][start.second + mid];
                    if (start.second > 0) {
                        ans -= pref_close_i[start.first][start.second - 1];
                    }
                    if (ans == 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int first_ans = l;
                // в l лежит сколько максимально шагов я могу сделать
                // теперь мне нужно сделать БП по количеству шагов, учитывая ключи и двери
                l = 0, r = m - start.second;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans1 = pref_door_i[start.first][start.second + mid];
                    if (start.second > 0) {
                        ans1 -= pref_door_i[start.first][start.second - 1];
                    }
                    int ans2 = pref_key_i[start.first][start.second + mid];
                    if (start.second > 0) {
                        ans2 -= pref_key_i[start.first][start.second - 1];
                    }
                    if (ans2 - ans1 + cnt_keys >= 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int ans1 = pref_door_i[start.first][start.second + min(l, first_ans)];
                if (start.second > 0) {
                    ans1 -= pref_door_i[start.first][start.second - 1];
                }
                int ans2 = pref_key_i[start.first][start.second + min(l, first_ans)];
                if (start.second > 0) {
                    ans2 -= pref_key_i[start.first][start.second - 1];
                }
                cnt_keys = ans2 - ans1 + cnt_keys;
                start.second += min(l, first_ans);
                cout << min(l, first_ans) << "\n";
            }
            else if (s[i] == 'L') {
                // найти первую клетку, в которой единица
                // БП по скольки шагам я могу сделать [l, r)
                int l = 0, r = start.second + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans = pref_close_i[start.first][start.second];
                    if (start.second - mid > 0) {
                        ans -= pref_close_i[start.first][start.second - mid - 1];
                    }
                    if (ans == 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int first_ans = l;
                // в l лежит сколько максимально шагов я могу сделать
                // теперь мне нужно сделать БП по количеству шагов, учитывая ключи и двери
                l = 0, r = start.second + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans1 = pref_door_i[start.first][start.second];
                    if (start.second - mid > 0) {
                        ans1 -= pref_door_i[start.first][start.second - mid - 1];
                    }
                    int ans2 = pref_key_i[start.first][start.second];
                    if (start.second - mid > 0) {
                        ans2 -= pref_key_i[start.first][start.second - mid - 1];
                    }
                    if (ans2 - ans1 + cnt_keys >= 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int ans1 = pref_door_i[start.first][start.second];
                if (start.second - min(l, first_ans) > 0) {
                    ans1 -= pref_door_i[start.first][start.second - min(l, first_ans) - 1];
                }
                int ans2 = pref_key_i[start.first][start.second];
                if (start.second - min(l, first_ans) > 0) {
                    ans2 -= pref_key_i[start.first][start.second - min(l, first_ans) - 1];
                }
                cnt_keys = ans2 - ans1 + cnt_keys;
                start.second -= min(l, first_ans);
                cout << min(l, first_ans) << "\n";
            }
            else if (s[i] == 'D') {
                // найти первую клетку, в которой единица
                // БП по скольки шагам я могу сделать [l, r)
                int l = 0, r = n - start.first;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans = pref_close_j[start.second][start.first + mid];
                    if (start.first > 0) {
                        ans -= pref_close_j[start.second][start.first - 1];
                    }
                    if (ans == 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int first_ans = l;
                // в l лежит сколько максимально шагов я могу сделать
                // теперь мне нужно сделать БП по количеству шагов, учитывая ключи и двери
                l = 0, r = n - start.first;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans1 = pref_door_j[start.second][start.first + mid];
                    if (start.first > 0) {
                        ans1 -= pref_door_j[start.second][start.first - 1];
                    }
                    int ans2 = pref_key_j[start.second][start.first + mid];
                    if (start.first > 0) {
                        ans2 -= pref_key_j[start.second][start.first - 1];
                    }
                    if (ans2 - ans1 + cnt_keys >= 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int ans1 = pref_door_j[start.second][start.first + min(l, first_ans)];
                if (start.first > 0) {
                    ans1 -= pref_door_j[start.second][start.first - 1];
                }
                int ans2 = pref_key_j[start.second][start.first + min(l, first_ans)];
                if (start.first > 0) {
                    ans2 -= pref_key_j[start.second][start.first - 1];
                }
                cnt_keys = ans2 - ans1 + cnt_keys;
                start.first += min(l, first_ans);
                cout << min(l, first_ans) << "\n";
            }
            if (s[i] == 'U') {
                // найти первую клетку, в которой единица
                // БП по скольки шагам я могу сделать [l, r)
                int l = 0, r = start.first + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans = pref_close_j[start.second][start.first];
                    if (start.first - mid > 0) {
                        ans -= pref_close_j[start.second][start.first - mid - 1];
                    }
                    if (ans == 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int first_ans = l;
                // в l лежит сколько максимально шагов я могу сделать
                // теперь мне нужно сделать БП по количеству шагов, учитывая ключи и двери
                l = 0, r = start.first + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    int ans1 = pref_door_j[start.second][start.first];
                    if (start.first - mid > 0) {
                        ans1 -= pref_door_j[start.second][start.first - mid - 1];
                    }
                    int ans2 = pref_key_j[start.second][start.first];
                    if (start.first - mid > 0) {
                        ans2 -= pref_key_j[start.second][start.first - mid - 1];
                    }
                    if (ans2 - ans1 + cnt_keys >= 0) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int ans1 = pref_door_j[start.second][start.first];
                if (start.first - min(l, first_ans) > 0) {
                    ans1 -= pref_door_j[start.second][start.first - min(l, first_ans) - 1];
                }
                int ans2 = pref_key_j[start.second][start.first];
                if (start.first - min(l, first_ans) > 0) {
                    ans2 -= pref_key_j[start.second][start.first - min(l, first_ans) - 1];
                }
                cnt_keys = ans2 - ans1 + cnt_keys;
                start.first -= min(l, first_ans);
                cout << min(l, first_ans) << "\n";
            }
        }
    }
    if (d == 1) {
        int cnt_keys = 0;
        for (int i = 0; i < sz; i++) {
            if (s[i] == 'R') {
                int steps = 0;
                while (true) {
                    if (start.second > m - 2 || a[start.first][start.second + 1] == '#' || a[start.first][start.second + 1] == 'L' && cnt_keys == 0) {
                        break;
                    }
                    if (a[start.first][start.second + 1] == 'K') {
                        cnt_keys++;
                    }
                    if (a[start.first][start.second + 1] == 'L') {
                        cnt_keys--;
                    }
                    a[start.first][start.second + 1] = 0;
                    start.second++;
                    steps++;
                }
                cout << steps << "\n";
            }
            else if (s[i] == 'L') {
                int steps = 0;
                while (true) {
                    if (start.second < 1 || a[start.first][start.second - 1] == '#' || a[start.first][start.second - 1] == 'L' && cnt_keys == 0) {
                        break;
                    }
                    if (a[start.first][start.second - 1] == 'K') {
                        cnt_keys++;
                    }
                    if (a[start.first][start.second - 1] == 'L') {
                        cnt_keys--;
                    }
                    a[start.first][start.second - 1] = 0;
                    start.second--;
                    steps++;
                }
                cout << steps << "\n";
            }
            else if (s[i] == 'D') {
                int steps = 0;
                while (true) {
                    if (start.first > n - 2 || a[start.first + 1][start.second] == '#' || a[start.first + 1][start.second] == 'L' && cnt_keys == 0) {
                        break;
                    }
                    if (a[start.first + 1][start.second] == 'K') {
                        cnt_keys++;
                    }
                    if (a[start.first + 1][start.second] == 'L') {
                        cnt_keys--;
                    }
                    a[start.first + 1][start.second] = 0;
                    start.first++;
                    steps++;
                }
                cout << steps << "\n";
            }
            else if (s[i] == 'U') {
                int steps = 0;
                while (true) {
                    if (start.first < 1 || a[start.first - 1][start.second] == '#' || a[start.first - 1][start.second] == 'L' && cnt_keys == 0) {
                        break;
                    }
                    if (a[start.first - 1][start.second] == 'K') {
                        cnt_keys++;
                    }
                    if (a[start.first - 1][start.second] == 'L') {
                        cnt_keys--;
                    }
                    a[start.first - 1][start.second] = 0;
                    start.first--;
                    steps++;
                }
                cout << steps << "\n";
            }
        }
    }
}