﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int>dsu;
vector<vector<int>>gr;
vector<string>ans;

int Find(int u) {
    return (dsu[u] == u ? u : dsu[u] = Find(dsu[u]));
}

void Union(int a, int b) {
    a = Find(a), b = Find(b);
    if (rand() % 2) {
        dsu[a] = b;
    }
    else {
        dsu[b] = a;
        ans[a] = ans[b];
    }
}

map<string, int>ma;
map<int, string>am;
int cnt = 0;

void add(string a, string b) {
    if (ma.find(a) == ma.end()) {
        ma[a] = cnt++;
        am[cnt - 1] = a;
        gr.push_back({});
        dsu.push_back(cnt - 1);
        ans.push_back(a);
    }
    if (ma.find(b) == ma.end()) {
        ma[b] = cnt++;
        am[cnt - 1] = b;
        gr.push_back({});
        dsu.push_back(cnt - 1);
        ans.push_back(b);
    }
    if (gr[ma[a]].size() == 0 || gr[ma[a]].back() != ma[b]) {
        gr[ma[a]].push_back(ma[b]);
    }
    Union(ma[a], ma[b]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        string a, s, b; cin >> a >> s >> b;
        add(a, b);
    }
    int q; cin >> q;
    int cq = q;
    while (cq--) {
        char tp; cin >> tp;
        if (tp == '+') {
            string a, s, b; cin >> a >> s >> b;
            add(a, b);
        }
        else {
            string a; cin >> a;
            if (ma.find(a) == ma.end()) {
                ma[a] = cnt++;
                am[cnt - 1] = a;
                gr.push_back({});
                dsu.push_back(cnt - 1);
                ans.push_back(a);
            }
            if (q <= 1000 && n <= 1000) {
                int st = ma[a];
                int num = st;
                string nans;
                vector<int>used(gr.size());
                while (true) {
                    used[num] = 1;
                    if (gr[num].size() > 1) {
                        nans = "TOO COMPLEX";
                        break;
                    }
                    else if (gr[num].size() == 0) {
                        nans = am[num];
                        break;
                    }
                    if (gr[num][0] == num) {
                        nans = am[num];
                        break;
                    }
                    if (used[gr[num][0]] == 1) {
                        nans = "INFINITE LOOP";
                        break;
                    }
                    if (gr[num][0] == st) {
                        nans = "INFINITE LOOP";
                        break;
                    }
                    num = gr[num][0];
                }
                cout << nans << "\n";
            }
            else {
                cout << ans[Find(ma[a])] << "\n";
            }
        }
    }
}