#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>
#include <map>
#include <set>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, d, si = 0, sj = 0;
	cin >> n >> m >> d;
	vector<string> a(n);
	vector<vector<int>> left(n, vector<int>(m));
	vector<vector<int>> right(n, vector<int>(m));
	vector<vector<int>> up(n, vector<int>(m));
	vector<vector<int>> down(n, vector<int>(m));
	vector<set<int>> d1(n), d2(m), k1(n), k2(m);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	for (int i = 0; i < n; ++i) {
		int l = -1;
		for (int j = 0; j < m; ++j) {

			if (a[i][j] == 'L') {
				d1[i].insert(j);
				d2[j].insert(i);
			}
			if (a[i][j] == 'K') {
				k1[i].insert(j);
				k2[j].insert(i);
			}

			if (a[i][j] == '#')
				l = j;
			left[i][j] = l;
			if (a[i][j] == 'S') {
				si = i;
				sj = j;
			}
		}
		l = m;
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j] == '#')
				l = j;
			right[i][j] = l;
		}
	}
	for (int i = 0; i < m; ++i) {
		int l = -1;
		for (int j = 0; j < n; ++j) {
			if (a[j][i] == '#')
				l = j;
			up[j][i] = l;
		}
		l = n;
		for (int j = n - 1; j >= 0; --j) {
			if (a[j][i] == '#')
				l = j;
			down[j][i] = l;
		}
	}

	int q, keys = 0;
	string qs;
	cin >> q >> qs;
	for (int p = 0; p < q; ++p) {
		if (qs[p] == 'L') {
			auto it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
			auto it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
			int to = left[si][sj] + 1;

			while (true) {
				if (it1 == k1[si].begin()) {
					if (it2 == d1[si].begin())
						break;
					it2--;
					if (*it2 >= to) {
						if (keys == 0) {
							to = *it2 + 1;
							break;
						}
						else {
							keys--;
							d2[*it2].erase(si);
							d1[si].erase(it2);
							it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
						}
					}
					else
						break;
				}
				else if (it2 == d1[si].begin()) {
					if (it1 == k1[si].begin()) {
						break;
					}
					it1--;
					if (*it1 >= to) {
						keys++; 
						k2[*it1].erase(si);
						k1[si].erase(it1);
						it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
					}
				}
				else {
					it2--;
					it1--;
					if (*it1 > * it2) {
						if (*it1 >= to) {
							keys++;
							k2[*it1].erase(si);
							k1[si].erase(it1);
						}
						else
							break;
					}
					else {
						if (*it2 >= to) {
							if (keys == 0) {
								to = *it2 + 1;
								break;
							}
							else {
								keys--;
								d2[*it2].erase(si);
								d1[si].erase(it2);
							}
						}
						else
							break;
					}
					it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
					it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
				}
			}



			cout << abs(to - sj) << '\n';
			sj = to;
		}


		if (qs[p] == 'R') {
			auto it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
			auto it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
			int to = right[si][sj] - 1;

			while (true) {
				if (it1 == k1[si].end()) {
					if (it2 == d1[si].end())
						break;
					if (*it2 <= to) {
						if (keys == 0) {
							to = *it2 - 1;
							break;
						}
						else {
							keys--;
							d2[*it2].erase(si);
							d1[si].erase(it2);
							it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
						}
					}
					else
						break;
				}
				else if (it2 == d1[si].end()) {
					if (it1 == k1[si].end())
						break;
					if (*it1 <= to) {
						keys++;
						k2[*it1].erase(si);
						k1[si].erase(it1);
						it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
					}
					else
						break;
				}
				else {
					if (*it1 < *it2) {
						if (*it1 <= to) {
							keys++;
							k2[*it1].erase(si);
							k1[si].erase(it1);
							it1 = lower_bound(k1[si].begin(), k1[si].end(), sj);
						}
						else
							break;
					}
					else {
						if (*it2 <= to) {
							if (keys == 0) {
								to = *it2 - 1;
								break;
							}
							else {
								keys--;
								d2[*it2].erase(si);
								d1[si].erase(it2);
								it2 = lower_bound(d1[si].begin(), d1[si].end(), sj);
							}
						}
						else
							break;
					}
				}
			}

			cout << abs(to - sj) << '\n';
			sj = to;
		}
		if (qs[p] == 'U') {
			auto it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
			auto it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
			int to = up[si][sj] + 1;

			while (true) {
				if (it1 == k2[sj].begin()) {
					if (it2 == d2[sj].begin())
						break;
					it2--;
					if (*it2 >= to) {
						if (keys == 0) {
							to = *it2 + 1;
							break;
						}
						else {
							keys--;
							d1[*it2].erase(sj);
							d2[sj].erase(it2);
							it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
						}
					}
					else
						break;
				}
				else if (it2 == d2[sj].begin()) {
					if (it1 == k2[sj].begin()) {
						break;
					}
					it1--;
					if (*it1 >= to) {
						keys++;
						k1[*it1].erase(sj);
						k2[sj].erase(it1);
						it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
					}
				}
				else {
					it2--;
					it1--;
					if (*it1 > * it2) {
						if (*it1 >= to) {
							keys++;
							k1[*it1].erase(sj);
							k2[sj].erase(it1);
						}
						else
							break;
					}
					else {
						if (*it2 >= to) {
							if (keys == 0) {
								to = *it2 + 1;
								break;
							}
							else {
								keys--;
								d1[*it2].erase(sj);
								d2[sj].erase(it2);
							}
						}
						else
							break;
					}
					it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
					it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
				}
			}
			cout << abs(to - si) << '\n';
			si = to;
		}


		if (qs[p] == 'D') {
			auto it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
			auto it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
			int to = down[si][sj] - 1;

			while (true) {
				if (it1 == k1[si].end()) {
					if (it2 == d1[si].end())
						break;
					if (*it2 <= to) {
						if (keys == 0) {
							to = *it2 - 1;
							break;
						}
						else {
							keys--;
							d1[*it2].erase(sj);
							d2[sj].erase(it2);
							it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
						}
					}
					else
						break;
				}
				else if (it2 == d2[sj].end()) {
					if (it1 == k2[sj].end())
						break;
					if (*it1 <= to) {
						keys++;
						k1[*it1].erase(sj);
						k2[sj].erase(it1);
						it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
					}
					else
						break;
				}
				else {
					if (*it1 < *it2) {
						if (*it1 <= to) {
							keys++;
							k1[*it1].erase(sj);
							k2[sj].erase(it1);
							it1 = lower_bound(k2[sj].begin(), k2[sj].end(), si);
						}
						else
							break;
					}
					else {
						if (*it2 <= to) {
							if (keys == 0) {
								to = *it2 - 1;
								break;
							}
							else {
								keys--;
								d1[*it2].erase(sj);
								d2[sj].erase(it2);
								it2 = lower_bound(d2[sj].begin(), d2[sj].end(), si);
							}
						}
						else
							break;
					}
				}
			}

			cout << abs(to - si) << '\n';
			sj = to;
		}
	}
	return 0;
}