#include <iostream>
#include <string>
#include <unordered_map>
#include <unordered_set>

#define maxN 200000

struct state {
	long long p = -1, next = -1;
	bool inf = false, comp = false;
} DSU[maxN];

long long n, it = 0, q;
std::string a, b;
std::unordered_map<std::string, long long> dict;
std::unordered_map<long long, std::string> dict0;
std::unordered_set<long long> used;

void unite(long long a, long long b) {
	DSU[a].next = b;
	DSU[a].p = b;
	return;
}

long long get(long long a) {
	if (a == DSU[a].next) {
		return a;
	}
	if (used.find(a) != used.end()) {
		return -2;
	}
	used.insert(a);
	if (DSU[a].comp) {
		return -1;
	}
	if (DSU[a].inf) {
		return -2;
	}
	if (DSU[a].p == -1) {
		return a;
	}
	long long g = get(DSU[a].p);
	if (g == -1) {
		DSU[a].comp = true;
		return -1;
	}
	if (g == -2) {
		DSU[a].inf = true;
		return -2;
	}
	DSU[a].p = g;
	return g;
}

int main() {
	std::cin >> n;
	for (long long i = 0; i < n; i++) {
		std::cin >> a >> b >> b;
		if (dict.find(a) == dict.end()) {
			dict[a] = it;
			dict0[it++] = a;
		}
		if (dict.find(b) == dict.end()) {
			dict[b] = it;
			dict0[it++] = b;
		}
		if (DSU[dict[a]].next != -1) {
			if (dict[b] == DSU[dict[a]].next) {
				continue;
			}
			DSU[dict[a]].comp = true;
			continue;
		}
		if (DSU[dict[a]].inf) {
			continue;
		}
		unite(dict[a], dict[b]);
	}
	std::cin >> q;
	for (long long i = 0; i < q; i++) {
		std::cin >> a;
		if (a == "?") {
			std::cin >> a;
			if (dict.find(a) == dict.end()) {
				dict[a] = it;
				dict0[it++] = a;
			}
			used = {};
			long long g = get(dict[a]);
			if (g == -1) {
				std::cout << "TOO COMPLEX\n";
				continue;
			}
			if (g == -2) {
				std::cout << "INFINITE LOOP\n";
				continue;
			}
			std::cout << dict0[g] << "\n";
		}
		if (a == "+") {
			std::cin >> a >> b >> b;
			if (dict.find(a) == dict.end()) {
				dict[a] = it;
				dict0[it++] = a;
			}
			if (dict.find(b) == dict.end()) {
				dict[b] = it;
				dict0[it++] = b;
			}
			if (DSU[dict[a]].next != -1) {
				if (dict[b] == DSU[dict[a]].next) {
					continue;
				}
				DSU[dict[a]].comp = true;
				continue;
			}
			if (DSU[dict[a]].inf) {
				continue;
			}
			unite(dict[a], dict[b]);
		}
	}
	return 0;
}