#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const ll N = 1e7;

struct point {
	int x = 0, y = 0;
	point(int x = 0, int y = 0) : x(x), y(y) {};
};

void Solve() {
	int m, n;
	cin >> m >> n;
	// main king's position;

	vector <point> kings(n);

	for (int i = 0; i < n; i++) {
		cin >> kings[i].x >> kings[i].y;	
	}

	ll answer = 0;

	int xp = kings[0].x; // line x = xp
	int yp = kings[0].y; // line y = yp
	int xpyp = kings[0].x + kings[0].y; // line x + y = xpyp
	int xmyp = kings[0].x - kings[0].y; // line x - y = xpyp

	// x-line
	//{
		int onXline = 0;
		map <int, int> x_AppearedY;
		set <int> x_BadY;
		for (auto k : kings) {
			if (k.x == xp) onXline++;
			else {
				// y-line inters.
				x_AppearedY[k.y]++;
				// x+y-line 
				if (1 <= k.x + k.y - xp && k.x + k.y - xp <= m)
					x_AppearedY[k.x + k.y - xp]++;
				// x-y-line
				if (1 <= k.y - k.x + xp && k.y - k.x + xp <= m)
					x_AppearedY[k.y - k.x + xp]++;
			}
			for (int x = k.x - 1; x <= k.x + 1; x++)
				for (int y = k.y - 1; y <= k.y + 1; y++)
					if (x == xp && x >= 1 && y >= 1 && x <= m && y <= m)
						x_BadY.insert(y);
		}
		if (onXline == n) answer += m - (int)x_BadY.size();
		else {
			for (auto i : x_AppearedY) {
				if (i.second + onXline == n && !x_BadY.count(i.first))
					answer++;
			}
		}
	//}

	// y-line
	//{
		int onYline = 0;
		map <int, int> y_AppearedX;
		set <int> y_BadX;
		for (auto k : kings) {
			if (k.y == yp) onYline++;
			else {
				// x-line inters.
				y_AppearedX[k.x]++;
				// x+y-line 
				if (1<= k.x + k.y - yp && k.x + k.y - yp <= m)
				y_AppearedX[k.x + k.y - yp]++;
				// x-y-line
				if (1 <= k.x - k.y + yp && k.x - k.y + yp <= m)
					y_AppearedX[k.x - k.y + yp]++;
			}
			for (int x = k.x - 1; x <= k.x + 1; x++)
				for (int y = k.y - 1; y <= k.y + 1; y++)
					if (y == yp && x >= 1 && y >= 1 && x <= m && y <= m)
						y_BadX.insert(x);
		}
		if (onYline == n) answer += m - (int)y_BadX.size();
		else {
			for (auto i : y_AppearedX) {
				if (i.second + onYline == n && !y_BadX.count(i.first))
					answer++;
			}
		}
	//}

	// x+y-line
	//{
		int onXpYline = 0;
		map <int, int> xpy_AppearedX;
		set <int> xpy_BadX;
		for (auto k : kings) {
			if (k.x + k.y == xpyp) onXpYline++;
			else {
				// x-line inters.
				xpy_AppearedX[k.x]++;
				// y-line 
				if (xpyp - k.y >= 1)
				xpy_AppearedX[xpyp - k.y]++;
				// x-y-line
				if ((xpyp + k.x - k.y) % 2 == 0)
					xpy_AppearedX[(xpyp + k.x - k.y) / 2]++;
			}
			for (int x = k.x - 1; x <= k.x + 1; x++)
				for (int y = k.y - 1; y <= k.y + 1; y++)
					if (x + y == xpyp && x >= 1 && y >= 1 && x <= m && y <= m)
						xpy_BadX.insert(x);
		}
		if (onXpYline == n) {
			answer += min(2 * m - xpyp + 1, xpyp - 1) - (int)xpy_BadX.size();
		}
		else {
			for (auto i : xpy_AppearedX) {
				if (i.second + onXpYline == n && !xpy_BadX.count(i.first) &&
					i.first >= 1 && i.first <= m && xpyp - i.first >= 1 && xpyp - i.first <= m)
					answer++;
			}
		}
	//}

	// x-y-line
	//{
		int onXmYline = 0;
		map <int, int> xmy_AppearedX;
		set <int> xmy_BadX;
		for (auto k : kings) {
			if (k.x - k.y == xmyp) onXmYline++;
			else {
				// x-line inters.
				xmy_AppearedX[k.x]++;
				// y-line 
				xmy_AppearedX[xmyp + k.y]++;
				// x-y-line
				if ((xmyp + k.x + k.y) % 2 == 0)
					xmy_AppearedX[(xmyp + k.x + k.y) / 2]++;
			}
			for (int x = k.x - 1; x <= k.x + 1; x++)
				for (int y = k.y - 1; y <= k.y + 1; y++)
					if (x - y == xmyp && x >= 1 && y >= 1 && x <= m && y <= m)
						xmy_BadX.insert(x);
		}
		if (onXmYline == n) {
			answer += m - abs(xmyp) - (int)xmy_BadX.size();
		}
		else {
			for (auto i : xmy_AppearedX) {
				if (i.second + onXmYline == n && !xmy_BadX.count(i.first) &&
					i.first >= 1 && i.first <= m && -xmyp + i.first >= 1 && -xmyp + i.first <= m)
					answer++;
			}
		}
	//}

	cout << answer << '\n';
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
		Solve();
}