#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e7;

char GetChar() { return getchar_unlocked(); }
int ReadInt() {
	char c = GetChar();
	while (!('0' <= c && c <= '9')) c = GetChar();
	int res = 0;
	while ('0' <= c && c <= '9') {
		res = res * 10 + c - '0';
		c = GetChar();
	}
	return res;
}

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void Solve() {
	int n= ReadInt();
	vector <bool> used(N);
	vector <int> ans(N, INF);
	ll c = 1;
	for (int i = 0; i < n; i++) {
		int q = ReadInt() + 1;
		if (used[q]) continue;
		used[q] = true;
		for (ll j = 0; j < N; j += c) {
			if (j % q != 0) ans[j] = i + 1;
		}
		c = min((ll)N, max(c, c / gcd(c, q) * q));
	}
	n = ReadInt();
	for (int i = 0; i < n; i++) {
		int q = ReadInt() - 1;
		if (ans[q] == INF) cout << "-1\n";
		else cout << ans[q] << "\n";
	}

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}