#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e6;
const int MOD = (int)1e9 + 7;

struct Point {
	int x, y, s;
	Point(int x = 0, int y = INF, int s = 0) : x(x), y(y), s(s) {}

	bool operator < (const Point& p) const {
		return x < p.x;
	}
};

int merge(set<Point>& a, set<Point>& b, int s, int t) {
	if (a.size() < b.size()) {
		swap(a, b);
		swap(s, t);
	}
	for (auto p : b) {
		auto it = a.upper_bound(p);
		if (it != a.end() && p.y <= it->y)
			continue;
		if (it != a.end()) {
			s -= it->s;
			auto p1 = *it;
			a.erase(it);
			p1.s = (p1.y * (p1.x - p.x));
			a.insert(p1);
			s += p1.s;
		}
		while (true) {
			auto it = a.upper_bound(p);
			if (it == a.begin()) {
				p.s = p.x * p.y;
				s += p.s;
				a.insert(p);
				break;
			}
			--it;
			if (it->y > p.y) {
				p.s = p.y * (p.x - it->x);
				s += p.s;
				a.insert(p);
				break;
			}
			s -= it->s;
			a.erase(it);
		}
	}
	return s;
}

void dfs(int v, vvi& g, vii& a, vi& ans, set<Point>& t) {
	t = { {a[v].first, a[v].second, a[v].first * a[v].second} };
	ans[v] = a[v].first * a[v].second;
	for (int u : g[v]) {
		set<Point> s;
		dfs(u, g, a, ans, s);
		ans[v] = merge(t, s, ans[v], ans[u]);
	}
	return;
}

void solve() {
	
	int n;
	cin >> n;
	vvi g(n);
	vii a(n);
	for (int i = 0; i < n; ++i) {
		int p;
		cin >> p >> a[i].first >> a[i].second;
		--p;
		if (p != -1)
			g[p].push_back(i);
	}
	vi ans(n);
	set<Point> s;
	dfs(0, g, a, ans, s);
	for (int i = 0; i < n; ++i)
		cout << ans[i] << endl;

	return;
}


signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	solve();

	return 0;
}