#include "iostream"
#include "vector"
#include "algorithm"

#define ll long long

using namespace std;

ll calc(vector<pair<int, int>>& cond)
{
	ll res = 0;
	int px = 0;
	for (pair<int, int>& p : cond)
	{
		res += (p.first - px) * p.second;
		px = p.first;
	}
	return res;
}

void dfs(vector<vector<int>>& g, vector<vector<pair<int, int>>>& c, vector<ll>& dp, int v = 1)
{
	if (g[v].empty())
	{
		dp[v] = calc(c[v]);
		return;
	}

	for (int to : g[v])
		dfs(g, c, dp, to);

	for (int to : g[v])
		for (pair<int, int>& p : c[to])
			c[v].push_back(p);
	sort(c[v].begin(), c[v].end());

	vector<pair<int, int>> s;
	for (pair<int, int>& p : c[v])
	{
		while (!s.empty() && s.back().second <= p.second)
			s.pop_back();
		s.push_back(p);
	}

	c[v] = s;
	dp[v] = calc(c[v]);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int n;
	cin >> n;
	vector<vector<int>> g(n + 1);
	vector<vector<pair<int, int>>> c(n + 1);
	for (int i = 1; i <= n; i++)
	{
		int p, a, b;
		cin >> p >> a >> b;
		g[p].push_back(i);
		c[i].push_back({ a, b });
	}

	vector<ll> dp(n + 1, 0);
	dfs(g, c, dp);

	for (int i = 1; i <= n; i++)
		cout << dp[i] << '\n';

	return 0;
}