#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

signed main() {
    fast_stream();
    // freopen("stdout.txt", "w", stdout);
    //freopen("avia.out", "w", stdout);
    ll h, w, d;
    cin >> h >> w >> d;
    vector<vector<char>> a(h, vector<char> (w));
    ll x, y;
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            cin >> a[i][j];
            if (a[i][j] == 'S') {
                x = i;
                y = j;
                a[i][j] = '.';
            }
        }
    }
    if (d == 0) {
        vector<vector<ll>> left(h, vector<ll> (w));
        for (ll j = 0; j < w; ++j) {
            for (ll i = 0; i < h; ++i) {
                if (j == 0) {
                    left[i][j] = 0LL;
                }
                else {
                    if (a[i][j - 1] == '#') {
                        left[i][j] = 0LL;
                    }
                    else {
                        left[i][j] = left[i][j - 1] + 1;
                    }
                }
            }
        }
        ///////////////
        vector<vector<ll>> right(h, vector<ll> (w));
        for (ll j = w - 1; j >= 0; --j) {
            for (ll i = 0; i < h; ++i) {
                if (j == w - 1) {
                    right[i][j] = 0LL;
                }
                else {
                    if (a[i][j + 1] == '#') {
                        right[i][j] = 0LL;
                    }
                    else {
                        right[i][j] = right[i][j + 1] + 1;
                    }
                }
            }
        }
        ///////////////
        vector<vector<ll>> up(h, vector<ll> (w));
        for (ll i = 0; i < h; ++i) {
            for (ll j = 0; j < w; ++j) {
                if (i == 0) {
                    up[i][j] = 0LL;
                }
                else {
                    if (a[i - 1][j] == '#') {
                        up[i][j] = 0LL;
                    }
                    else {
                        up[i][j] = up[i - 1][j] + 1;
                    }
                }
            }
        }
        ///////////////////////
        vector<vector<ll>> down(h, vector<ll> (w));
        for (ll i = h - 1; i >= 0; --i) {
            for (ll j = 0; j < w; ++j) {
                if (i == h - 1) {
                    down[i][j] = 0LL;
                }
                else {
                    if (a[i + 1][j] == '#') {
                        down[i][j] = 0LL;
                    }
                    else {
                        down[i][j] = down[i + 1][j] + 1;
                    }
                }
            }
        }
        ///////////////////////
        ll len;
        cin >> len;
        string s;
        cin >> s;
        for (auto i : s) {
            if (i == 'U') {
                cout << up[x][y] << '\n';
                x -= up[x][y];
            }
            if (i == 'D') {
                cout << down[x][y] << '\n';
                x += down[x][y];
            }
            if (i == 'R') {
                cout << right[x][y] << '\n';
                y += right[x][y];
            }
            if (i == 'L') {
                cout << left[x][y] << '\n';
                y -= left[x][y];
            }
        }
        return 0;
    }
    // cout << "OK" << endl;
    ll cnt_keys = 0LL;
    ll len;
    cin >> len;
    string s;
    cin >> s;
    for (auto i : s) {
        if (i == 'R') {
            ll izn_y = y;
            while (y < w) {
                if (a[x][y] == '.') {
                    ++y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++y;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --y;
            cout << y - izn_y << '\n';
        }
        else if (i == 'L') {
            ll izn_y = y;
            while (y >= 0) {
                if (a[x][y] == '.') {
                    --y;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --y;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --y;
                        continue;
                    }
                    break;
                }
                
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++y;
            cout << izn_y - y << '\n';
        }
        else if (i == 'U') {
            ll izn_x = x;
            while (x >= 0) {
                if (a[x][y] == '.') {
                    --x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    --x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        --x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            ++x;
            cout << izn_x - x << '\n';
        }
        else {
            ll izn_x = x;
            while (x < h) {
                if (a[x][y] == '.') {
                    ++x;
                    continue;
                }
                if (a[x][y] == 'K') {
                    ++cnt_keys;
                    a[x][y] = '.';
                    ++x;
                    continue;
                }
                if (a[x][y] == 'L') {
                    if (cnt_keys) {
                        --cnt_keys;
                        a[x][y] = '.';
                        ++x;
                        continue;
                    }
                    break;
                }
                if (a[x][y] == '#') {
                    break;
                }
            }
            --x;
            cout << x - izn_x << '\n';
        }
        // cout << endl;
    }
}