﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct obstacle
{
	char tp;
	int pos;
};

int n, m, d;
int si, sj;
vector < vector < obstacle > > hi, wi;

void go_r()
{
	int left = 0, right = hi[si].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if (hi[si][mid].pos < sj && hi[si][mid + 1].pos > sj)
		{
			left = mid;
			break;
		}
		else if (hi[si][mid].pos > sj)
			right = mid;
		else
			left = mid;
	}
	int next = hi[si][left + 1].pos - 1;
	cout << next - sj << endl;
	sj = next;
}

void go_l()
{
	int left = 0, right = hi[si].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if (hi[si][mid].pos < sj && hi[si][mid + 1].pos > sj)
		{
			left = mid;
			break;
		}
		else if (hi[si][mid].pos > sj)
			right = mid;
		else
			left = mid;
	}
	int next = hi[si][left].pos + 1;
	cout << sj - next << endl;
	sj = next;
}

void go_u()
{
	int left = 0, right = wi[sj].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if (wi[sj][mid].pos < si && wi[sj][mid + 1].pos > si)
		{
			left = mid;
			break;
		}
		else if (wi[sj][mid].pos > si)
			right = mid;
		else
			left = mid;
	}
	int next = wi[sj][left].pos + 1;
	cout << si - next << endl;
	si = next;
}

void go_d()
{
	int left = 0, right = wi[sj].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if (wi[sj][mid].pos < si && wi[sj][mid + 1].pos > si)
		{
			left = mid;
			break;
		}
		else if (wi[sj][mid].pos > si)
			right = mid;
		else
			left = mid;
	}
	int next = wi[sj][left + 1].pos - 1;
	cout << next - si << endl;
	si = next;
}

int main()
{
	cin >> n >> m >> d;
	hi.resize(n, vector < obstacle >());
	wi.resize(m, vector < obstacle >());
	for (int i = 0; i < n; i++)
		hi[i].push_back({ '#', -1 });
	for (int j = 0; j < m; j++)
		wi[j].push_back({ '#', -1 });
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			char c;
			cin >> c;
			if (c != '.')
			{
				if (c == 'S')
				{
					si = i, sj = j;
					continue;
				}
				hi[i].push_back({ c, j });
				wi[j].push_back({ c, i });
			}
		}
	}
	for (int i = 0; i < n; i++)
		hi[i].push_back({ '#', m });
	for (int j = 0; j < m; j++)
		wi[j].push_back({ '#', n });
	int q;
	string s;
	cin >> q >> s;
	for (int i = 0; i < q; i++)
	{
		switch (s[i])
		{
		case 'R':
			go_r();
			break;
		case 'L':
			go_l();
			break;
		case 'U':
			go_u();
			break;
		case 'D':
			go_d();
			break;
		}
	}

	return 0;
}