﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct obstacle
{
	char tp;
	int pos;
};

int n, m, d, ks;
int si, sj;
vector < vector < obstacle > > hi, wi;

int go_r()
{
	int left = 0, right = hi[si].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if ((hi[si][mid].pos < sj || hi[si][mid].pos == sj && hi[si][mid].tp == '.') && (hi[si][mid + 1].pos > sj || hi[si][mid + 1].pos == sj && hi[si][mid + 1].tp == '.'))
		{
			left = mid;
			break;
		}
		else if (hi[si][mid].pos > sj)
			right = mid;
		else
			left = mid;
	}
	int next = hi[si][left + 1].pos - 1;
	int len = next - sj;
	sj = next;
	if (hi[si][left + 1].tp == 'K')
	{
		ks++, sj++;
		//hi[si][left + 1].tp = '.';
		hi[si].erase(hi[si].begin() + left + 1);
		len += 1 + go_r();
	}
	if (hi[si][left + 1].tp == 'L' && ks > 0)
	{
		ks--, sj++;
		//hi[si][left + 1].tp = '.';
		hi[si].erase(hi[si].begin() + left + 1);
		len += 1 + go_r();
	}
	return len;
}

int go_l()
{
	int left = 0, right = hi[si].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if ((hi[si][mid].pos < sj || hi[si][mid].pos == sj && hi[si][mid].tp == '.') && (hi[si][mid + 1].pos > sj || hi[si][mid + 1].pos == sj && hi[si][mid + 1].tp == '.'))
		{
			left = mid;
			break;
		}
		else if (hi[si][mid].pos > sj)
			right = mid;
		else
			left = mid;
	}
	int next = hi[si][left].pos + 1;
	int len = sj - next;
	sj = next;
	if (hi[si][left].tp == 'K')
	{
		ks++, sj--;
		//hi[si][left].tp = '.';
		hi[si].erase(hi[si].begin() + left);
		len += 1 + go_l();
	}
	if (hi[si][left].tp == 'L' && ks > 0)
	{
		ks--, sj--;
		//hi[si][left].tp = '.';
		hi[si].erase(hi[si].begin() + left);
		len += 1 + go_l();
	}
	return len;
}

int go_u()
{
	int left = 0, right = wi[sj].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if ((wi[sj][mid].pos < si || wi[sj][mid].pos == si && wi[sj][mid].tp == '.') && (wi[sj][mid + 1].pos > si || wi[sj][mid + 1].pos == si && wi[sj][mid + 1].tp == '.'))
		{
			left = mid;
			break;
		}
		else if (wi[sj][mid].pos > si)
			right = mid;
		else
			left = mid;
	}
	int next = wi[sj][left].pos + 1;
	int len = si - next;
	si = next;
	if (wi[sj][left].tp == 'K')
	{
		ks++, si--;
		//wi[sj][left].tp = '.';
		wi[sj].erase(wi[sj].begin() + left);
		len += 1 + go_u();
	}
	if (wi[sj][left].tp == 'L' && ks > 0)
	{
		ks--, si--;
		//wi[sj][left].tp = '.';
		wi[sj].erase(wi[sj].begin() + left);
		len += 1 + go_u();
	}
	return len;
}

int go_d()
{
	int left = 0, right = wi[sj].size() - 1;
	while (left + 1 < right)
	{
		int mid = (left + right) >> 1;
		if ((wi[sj][mid].pos < si || wi[sj][mid].pos == si && wi[sj][mid].tp == '.') && (wi[sj][mid + 1].pos > si || wi[sj][mid + 1].pos == si && wi[sj][mid + 1].tp == '.'))
		{
			left = mid;
			break;
		}
		else if (wi[sj][mid].pos > si)
			right = mid;
		else
			left = mid;
	}
	int next = wi[sj][left + 1].pos - 1;
	int len = next - si;
	si = next;
	if (wi[sj][left + 1].tp == 'K')
	{
		ks++, si++;
		//wi[sj][left + 1].tp = '.';
		wi[sj].erase(wi[sj].begin() + left + 1);
		len += 1 + go_d();
	}
	if (wi[sj][left + 1].tp == 'L' && ks > 0)
	{
		ks--, si++;
		//wi[sj][left + 1].tp = '.';
		wi[sj].erase(wi[sj].begin() + left + 1);
		len += 1 + go_d();
	}
	return len;
}

void solve_fast()
{
	hi.resize(n, vector < obstacle >());
	wi.resize(m, vector < obstacle >());
	for (int i = 0; i < n; i++)
		hi[i].push_back({ '#', -1 });
	for (int j = 0; j < m; j++)
		wi[j].push_back({ '#', -1 });
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			char c;
			cin >> c;
			if (c != '.')
			{
				if (c == 'S')
				{
					si = i, sj = j;
					continue;
				}
				hi[i].push_back({ c, j });
				wi[j].push_back({ c, i });
			}
		}
	}
	for (int i = 0; i < n; i++)
		hi[i].push_back({ '#', m });
	for (int j = 0; j < m; j++)
		wi[j].push_back({ '#', n });
	int q;
	string s;
	cin >> q >> s;
	for (int i = 0; i < q; i++)
	{
		switch (s[i])
		{
		case 'R':
			cout << go_r() << endl;
			break;
		case 'L':
			cout << go_l() << endl;
			break;
		case 'U':
			cout << go_u() << endl;
			break;
		case 'D':
			cout << go_d() << endl;
			break;
		}
	}
}

void solve_slow()
{
	vector < vector < char > > pole(n, vector < char >(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			cin >> pole[i][j];
			if (pole[i][j] == 'S')
				si = i, sj = j;
		}
	int q;
	string s;
	cin >> q >> s;
	for (int i = 0; i < q; i++)
	{
		int len = 0;
		switch (s[i])
		{
		case 'R':
			while (sj + 1 < m && pole[si][sj + 1] != '#')
			{
				if (pole[si][sj + 1] == 'K')
					ks++, sj++, pole[si][sj] = '.';
				else if (pole[si][sj + 1] == 'L')
					if (ks > 0)
						ks--, sj++, pole[si][sj] = '.';
					else
						break;
				else
					sj++;
				len++;
			}
			cout << len << endl;
			break;
		case 'L':
			while (sj - 1 >= 0 && pole[si][sj - 1] != '#')
			{
				if (pole[si][sj - 1] == 'K')
					ks++, sj--, pole[si][sj] = '.';
				else if (pole[si][sj - 1] == 'L')
					if (ks > 0)
						ks--, sj--, pole[si][sj] = '.';
					else
						break;
				else
					sj--;
				len++;
			}
			cout << len << endl;
			break;
		case 'U':
			while (si - 1 >= 0 && pole[si - 1][sj] != '#')
			{
				if (pole[si - 1][sj] == 'K')
					ks++, si--, pole[si][sj] = '.';
				else if (pole[si - 1][sj] == 'L')
					if (ks > 0)
						ks--, si--, pole[si][sj] = '.';
					else
						break;
				else
					si--;
				len++;
			}
			cout << len << endl;
			break;
		case 'D':
			while (si + 1 < n && pole[si + 1][sj] != '#')
			{
				if (pole[si + 1][sj] == 'K')
					ks++, si++, pole[si][sj] = '.';
				else if (pole[si + 1][sj] == 'L')
					if (ks > 0)
						ks--, si++, pole[si][sj] = '.';
					else
						break;
				else
					si++;
				len++;
			}
			cout << len << endl;
			break;
		}
	}
}

int main()
{
	cin >> n >> m >> d;
	if (n * m > 100)
		solve_fast();
	else
		solve_slow();

	return 0;
}