﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

int n, q, idx = 0;
map < string, int > mp;
vector < string > vs;
vector < bool > used;
vector < set < int > > g;

void add()
{
	string s1, s2;
	cin >> s1 >> s2 >> s2;
	if (mp.find(s1) == mp.end())
	{
		mp[s1] = idx++;
		vs.push_back(s1);
		g.push_back(set < int >());
	}
	if (mp.find(s2) == mp.end())
	{
		mp[s2] = idx++;
		vs.push_back(s2);
		g.push_back(set < int >());
	}
	g[mp[s1]].insert(mp[s2]);
}

int dfs(int u)
{
	if (g[u].size() == 1 && *g[u].begin() == u)
		return u;
	used[u] = true;
	if (g[u].size() > 1)
		return -1;
	else if (g[u].size() == 1 && used[*g[u].begin()])
		return -2;
	else if (g[u].size() == 1)
		return dfs(*g[u].begin());
	else if (g[u].size() == 0)
		return u;
}

void check()
{
	string s;
	cin >> s;
	if (mp.find(s) == mp.end())
	{
		cout << s << endl;
		return;
	}
	used.assign(idx + 1, false);
	int res = dfs(mp[s]);
	if (res == -1)
		cout << "TOO COMPLEX\n";
	else if (res == -2)
		cout << "INFINITE LOOP\n";
	else
		cout << vs[res] << endl;
}

int main()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		string s1, s2;
		cin >> s1 >> s2 >> s2;
		if (mp.find(s1) == mp.end())
		{
			mp[s1] = idx++;
			vs.push_back(s1);
			g.push_back(set < int >());
		}
		if (mp.find(s2) == mp.end())
		{
			mp[s2] = idx++;
			vs.push_back(s2);
			g.push_back(set < int >());
		}
		g[mp[s1]].insert(mp[s2]);
	}
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		char type;
		cin >> type;
		if (type == '+')
			add();
		else if (type == '?')
			check();
		else
			throw 1;
	}

	return 0;
}